use clap::Parser;
use color_eyre::Result;

use crate::handler::Handler;

mod config;
mod ha_client;
mod handler;

#[derive(Debug, Parser)]
#[command(name = "home_assistant")]
enum CliCommand {
    #[command(name = "deckster-run", hide = true)]
    Run,
}

fn main() -> Result<()> {
    env_logger::init();
    let command = CliCommand::parse();

    match command {
        CliCommand::Run => {
            deckster_mode::run(Handler::new)?;
        }
    }

    Ok(())
}
