use clap::Parser;
use color_eyre::Result;

use crate::handler::Handler;

mod handler;
mod util;

#[derive(Debug, Parser)]
#[command(name = "timer")]
enum CliCommand {
    #[command(name = "deckster-run", hide = true)]
    Run,
}

fn main() -> Result<()> {
    env_logger::init();
    let command = CliCommand::parse();

    match command {
        CliCommand::Run => {
            deckster_mode::run(Handler::new)?;
        }
    }

    Ok(())
}
