use std::fmt;

pub trait UnwrapExt<T> {
    fn unwrap_todo(self) -> T;
}

impl<T> UnwrapExt<T> for Option<T> {
    #[inline]
    fn unwrap_todo(self) -> T {
        self.expect("TODO: Handle this Option being None")
    }
}

impl<T, E: fmt::Debug> UnwrapExt<T> for Result<T, E> {
    #[inline]
    fn unwrap_todo(self) -> T {
        self.expect("TODO: Handle this error")
    }
}
